-- Author: Average Enjoyer ^ω^ Lampovo Project
-- Date: 29.02.2024
-- Version: 1.0.0.0

-- vk.com/lampovofs

licensePlatesStandalone = {}
licensePlatesStandalone.modDir = g_currentModDirectory

MaterialManager.loadFontMaterialsXML = Utils.appendedFunction(MaterialManager.loadFontMaterialsXML, function (self, xmlFilename, customEnvironment, baseDirectory, ...)
    local xmlFilename = Utils.getFilename('data/fonts.xml', licensePlatesStandalone.modDir)
    local xmlFile = XMLFile.load("TempFonts", xmlFilename, MaterialManager.fontMaterialXMLSchema)
    if xmlFile ~= nil then
        xmlFile.references = 0

        xmlFile:iterate("fonts.font", function(index, key)
            local name = xmlFile:getValue(key .. "#name")
            local filename = xmlFile:getValue(key .. "#filename")
            local node = xmlFile:getValue(key .. "#node")
            local noNormalNode = xmlFile:getValue(key .. "#noNormalNode")
            local characterShapePath = xmlFile:getValue(key .. "#characterShape")
            if name ~= nil and filename ~= nil and node ~= nil then
                if customEnvironment ~= nil and customEnvironment ~= "" then
                    name = customEnvironment .. "." .. name
                end

                local font = {}
                font.name = name
                font.node = node
                font.noNormalNode = noNormalNode
                font.characterShapePath = characterShapePath

                xmlFile.references = xmlFile.references + 1

                filename = Utils.getFilename(filename, licensePlatesStandalone.modDir)

                local arguments = {
                    xmlFile = xmlFile,
                    key = key,
                    font = font
                }
                font.sharedLoadRequestId = g_i3DManager:loadSharedI3DFileAsync(filename, false, false, self.fontMaterialLoaded, self, arguments)
            end
        end)
    end
end)

LicensePlateManager.loadMapData = Utils.overwrittenFunction(LicensePlateManager.loadMapData, function (self, superFunc, xmlFile, missionInfo, baseDirectory)
    LicensePlateManager:superClass().loadMapData(self, xmlFile, missionInfo, baseDirectory)

    LicensePlateManager.createLicensePlateXMLSchema()

    local filename = getXMLString(xmlFile, "map.licensePlates#filename")
    if filename ~= nil then
        self.xmlFilename = Utils.getFilename('data/licensePlates.xml', licensePlatesStandalone.modDir)
        self.licensePlateXML = XMLFile.load("mapLicensePlates", self.xmlFilename, LicensePlateManager.xmlSchema)
        if self.licensePlateXML ~= nil then
            self.xmlReferences = 0
            self:loadLicensePlatesFromXML(self.licensePlateXML, licensePlatesStandalone.modDir)

            if self.licensePlateXML ~= nil and self.xmlReferences == 0 then
                self.licensePlateXML:delete()
                self.licensePlateXML = nil
            end
        end
    end

    return true
end)